Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3876)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3883)
@@ -4146,45 +4183,57 @@
       IMPLICIT NONE
 
-      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT) ::  f    !< Child-grid array
-      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN)        ::  fc   !< Parent-grid array
-      INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN)    ::  ifl  !< Indicates start index of child cells belonging to certain parent cell - x direction
-      INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN)    ::  ifu  !< Indicates end index of child cells belonging to certain parent cell - x direction
-      INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN)    ::  jfl  !< Indicates start index of child cells belonging to certain parent cell - y direction
-      INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN)    ::  jfu  !< Indicates end index of child cells belonging to certain parent cell - y direction
-      INTEGER(iwp) :: kct                                        !< The parent-grid index in z-direction just below the boundary value node
-      CHARACTER(LEN=1), INTENT(IN) :: var                        !< Variable symbol: 'u', 'v', 'w' or 's'
-!
-!--   Local variables:
+      INTEGER(iwp), INTENT(IN) ::  kct  !< The parent-grid index in z-direction just below the boundary value node
+      
+      INTEGER(iwp), DIMENSION(ipla:ipra), INTENT(IN) ::  ifl  !< Indicates start index of child cells belonging to certain
+                                                              !< parent cell - x direction
+      INTEGER(iwp), DIMENSION(ipla:ipra), INTENT(IN) ::  ifu  !< Indicates end index of child cells belonging to certain
+                                                              !< parent cell - x direction
+      INTEGER(iwp), DIMENSION(jpsa:jpna), INTENT(IN) ::  jfl  !< Indicates start index of child cells belonging to certain
+                                                              !< parent cell - y direction
+      INTEGER(iwp), DIMENSION(jpsa:jpna), INTENT(IN) ::  jfu  !< Indicates end index of child cells belonging to certain
+                                                              !< parent cell - y direction
+
+      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT) ::  child_array   !< Child-grid array
+      REAL(wp), DIMENSION(0:pg%nz+1,jps:jpn,ipl:ipr), INTENT(IN)        ::  parent_array  !< Parent-grid array
+
+      CHARACTER(LEN=1), INTENT(IN) ::  var                    !< Variable symbol: 'u', 'v', 'w' or 's'
+!
+!--   Local variables:      
+      INTEGER(iwp) ::  ic          !< Running child-grid index in the x-direction
+      INTEGER(iwp) ::  ierr        !< MPI error code
+      INTEGER(iwp) ::  iplc        !< Lower parent-grid index limit in the x-direction for copying parent-grid
+                                   !< array data to workarr_t
+      INTEGER(iwp) ::  iprc        !< Upper parent-grid index limit in the x-direction for copying parent-grid
+                                   !< array data to workarr_t
+      INTEGER(iwp) ::  jc          !< Running child-grid index in the y-direction
+      INTEGER(iwp) ::  jpsc        !< Lower parent-grid index limit in the y-direction for copying parent-grid
+                                   !< array data to workarr_t
+      INTEGER(iwp) ::  jpnc        !< Upper parent-grid-index limit in the y-direction for copying parent-grid
+                                   !< array data to workarr_t
+      INTEGER(iwp) ::  kc          !< Vertical child-grid index fixed to the boundary-value level 
+      INTEGER(iwp) ::  ip          !< Running parent-grid index in the x-direction
+      INTEGER(iwp) ::  jp          !< Running parent-grid index in the y-direction
+      INTEGER(iwp) ::  kpw         !< Reduced parent-grid index in the z-direction for workarr_t pointing to
+                                   !< the boundary ghost node
       REAL(wp)     ::  c31         !< Interpolation coefficient for the 3rd-order WS scheme
       REAL(wp)     ::  c32         !< Interpolation coefficient for the 3rd-order WS scheme
       REAL(wp)     ::  c33         !< Interpolation coefficient for the 3rd-order WS scheme
-      REAL(wp)     ::  f_interp_1  !< Value interpolated in z direction from the parent-grid data
-      REAL(wp)     ::  f_interp_2  !< Auxiliary value interpolated in z direction from the parent-grid data
-      INTEGER(iwp) ::  i           !< Child-grid index in x-direction
-      INTEGER(iwp) ::  iclc        !< Lower i-index limit for copying fc-data to workarrc_t
-      INTEGER(iwp) ::  icrc        !< Upper i-index limit for copying fc-data to workarrc_t
-      INTEGER(iwp) ::  ierr        !< MPI error code
-      INTEGER(iwp) ::  j           !< Child-grid index in y-direction
-      INTEGER(iwp) ::  jcsc        !< Lower j-index limit for copying fc-data to workarrc_t
-      INTEGER(iwp) ::  jcnc        !< Upper j-index limit for copying fc-data to workarrc_t
-      INTEGER(iwp) ::  k           !< Vertical child-grid index fixed to the boundary-value level 
-      INTEGER(iwp) ::  l           !< Parent-grid index in x-direction
-      INTEGER(iwp) ::  m           !< Parent-grid index in y-direction
-      INTEGER(iwp) ::  nw          !< Reduced n-index for workarrc_t pointing to the boundary ghost node 
+      REAL(wp)     ::  c_interp_1  !< Value interpolated to the flux point in z direction from the parent-grid data
+      REAL(wp)     ::  c_interp_2  !< Auxiliary value interpolated to the flux point in z direction from the parent-grid data
 
 
       IF ( var == 'w' )  THEN
-         k    = nzt
+         kc = nzt
       ELSE
-         k    = nzt + 1
+         kc = nzt + 1
       ENDIF
-      nw = 1
+      kpw = 1
 !
 !--   Interpolation coefficients
-      IF  ( interpolation_scheme_t == 1 )  THEN
+      IF ( interpolation_scheme_t == 1 )  THEN
          c31 =  0.0_wp           ! 1st-order upwind
          c32 =  1.0_wp
          c33 =  0.0_wp
-      ELSE IF  ( interpolation_scheme_t == 2 )  THEN
+      ELSE IF ( interpolation_scheme_t == 2 )  THEN
          c31 =  0.5_wp           ! 2nd-order central
          c32 =  0.5_wp
@@ -4197,26 +4246,25 @@
 !
 !--   Substitute the necessary parent-grid data to the work array. 
-!--   Note that the dimension of workarrc_t is (0:2,jcsw:jcnw,iclw:icrw),
+!--   Note that the dimension of workarr_t is (0:2,jpsw:jpnw,iplw:iprw),
 !--   And the jc?w and ic?w-index bounds depend on the location of the PE-
 !--   subdomain relative to the side boundaries. 
-      iclc = iclw + 1
-      icrc = icrw - 1      
-      jcsc = jcsw + 1
-      jcnc = jcnw - 1
-      IF  ( bc_dirichlet_l )  THEN
-         iclc = iclw
+      iplc = iplw + 1
+      iprc = iprw - 1      
+      jpsc = jpsw + 1
+      jpnc = jpnw - 1
+      IF ( bc_dirichlet_l )  THEN
+         iplc = iplw
       ENDIF
-      IF  ( bc_dirichlet_r )  THEN
-         icrc = icrw
+      IF ( bc_dirichlet_r )  THEN
+         iprc = iprw
       ENDIF
-      IF  ( bc_dirichlet_s )  THEN
-         jcsc = jcsw
+      IF ( bc_dirichlet_s )  THEN
+         jpsc = jpsw
       ENDIF
-      IF  ( bc_dirichlet_n )  THEN
-         jcnc = jcnw
+      IF ( bc_dirichlet_n )  THEN
+         jpnc = jpnw
       ENDIF
-      workarrc_t = 0.0_wp
-!      workarrc_t(-2:3,jcsc:jcnc,iclc:icrc) = fc(kct-2:kct+3,jcsc:jcnc,iclc:icrc)
-      workarrc_t(0:2,jcsc:jcnc,iclc:icrc) = fc(kct:kct+2,jcsc:jcnc,iclc:icrc)
+      workarr_t = 0.0_wp
+      workarr_t(0:2,jpsc:jpnc,iplc:iprc) = parent_array(kct:kct+2,jpsc:jpnc,iplc:iprc)
 !
 !--   Left-right exchange if more than one PE subdomain in the x-direction.
@@ -4224,49 +4272,41 @@
 !--   not exchanged because the nest domain is not cyclic.
 #if defined( __parallel )
-      IF  ( pdims(1) > 1 )  THEN
+      IF ( pdims(1) > 1 )  THEN
 !
 !--      From left to right
-         CALL MPI_SENDRECV( workarrc_t(0,jcsw,iclw+1), 1,                       &
-              workarrc_t_exchange_type_y, pleft,  0,                            &
-              workarrc_t(0,jcsw,icrw), 1,                                       &
-              workarrc_t_exchange_type_y, pright, 0,                            &
-              comm2d, status, ierr ) 
-!
-!--      From right to left        
-         CALL MPI_SENDRECV( workarrc_t(0,jcsw,icrw-1), 1,                       &
-              workarrc_t_exchange_type_y, pright, 1,                            &
-              workarrc_t(0,jcsw,iclw), 1,                                       &
-              workarrc_t_exchange_type_y, pleft,  1,                            &
-              comm2d, status, ierr )
-      ENDIF
-!
-!--   South-north exchange if more than one PE subdomain in the y-direction.
-!--   Note that in case of 3-D nesting the south and north boundaries are 
-!--   not exchanged because the nest domain is not cyclic.
-      IF  ( pdims(2) > 1 )  THEN
-!
-!--      From south to north         
-         CALL MPI_SENDRECV( workarrc_t(0,jcsw+1,iclw), 1,                       &
-              workarrc_t_exchange_type_x, psouth, 2,                            &
-              workarrc_t(0,jcnw,iclw), 1,                                       &
-              workarrc_t_exchange_type_x, pnorth, 2,                            &
-              comm2d, status, ierr ) 
-!
-!--      From north to south        
-         CALL MPI_SENDRECV( workarrc_t(0,jcnw-1,iclw), 1,                       &
-              workarrc_t_exchange_type_x, pnorth, 3,                            &
-              workarrc_t(0,jcsw,iclw), 1,                                       &
-              workarrc_t_exchange_type_x, psouth, 3,                            &
-              comm2d, status, ierr )
+         CALL MPI_SENDRECV( workarr_t(0,jpsw,iplw+1), 1, workarr_t_exchange_type_y, pleft, 0,       &
+                            workarr_t(0,jpsw,iprw), 1, workarr_t_exchange_type_y, pright, 0,        &
+                            comm2d, status, ierr )
+!                                                                              
+!--      From right to left                                                    
+         CALL MPI_SENDRECV( workarr_t(0,jpsw,iprw-1), 1, workarr_t_exchange_type_y, pright, 1,      &
+                            workarr_t(0,jpsw,iplw), 1, workarr_t_exchange_type_y, pleft,  1,        &
+                            comm2d, status, ierr )                                           
+      ENDIF                                                                    
+!                                                                              
+!--   South-north exchange if more than one PE subdomain in the y-direction.   
+!--   Note that in case of 3-D nesting the south and north boundaries are      
+!--   not exchanged because the nest domain is not cyclic.                     
+      IF ( pdims(2) > 1 )  THEN                                               
+!                                                                              
+!--      From south to north                                                   
+         CALL MPI_SENDRECV( workarr_t(0,jpsw+1,iplw), 1, workarr_t_exchange_type_x, psouth, 2,      &
+                            workarr_t(0,jpnw,iplw), 1, workarr_t_exchange_type_x, pnorth, 2,        &
+                            comm2d, status, ierr )                                           
+!                                                                              
+!--      From north to south                                                   
+         CALL MPI_SENDRECV( workarr_t(0,jpnw-1,iplw), 1, workarr_t_exchange_type_x, pnorth, 3,      &
+                            workarr_t(0,jpsw,iplw), 1, workarr_t_exchange_type_x, psouth, 3,        &
+                            comm2d, status, ierr )
       ENDIF
 #endif      
 
       IF  ( var == 'w' )  THEN
-         DO  l = iclw, icrw
-            DO  m = jcsw, jcnw
+         DO  ip = iplw, iprw
+            DO  jp = jpsw, jpnw
  
-               DO  i = ifl(l), ifu(l)
-                  DO  j = jfl(m), jfu(m)
-                     f(k,j,i) = workarrc_t(nw,m,l)
+               DO  ic = ifl(ip), ifu(ip)
+                  DO  jc = jfl(jp), jfu(jp)
+                     child_array(kc,jc,ic) = workarr_t(kpw,jp,ip)
                   ENDDO
                ENDDO
@@ -4277,25 +4317,25 @@
       ELSE IF  ( var == 'u' )  THEN
 
-         DO  l = iclw, icrw-1
-            DO  m = jcsw, jcnw
+         DO  ip = iplw, iprw - 1
+            DO  jp = jpsw, jpnw
 !
 !--            First interpolate to the flux point using the 3rd-order WS scheme
-               f_interp_1 = c31 * workarrc_t(nw-1,m,l)   + c32 * workarrc_t(nw,m,l)   + c33 * workarrc_t(nw+1,m,l)
-               f_interp_2 = c31 * workarrc_t(nw-1,m,l+1) + c32 * workarrc_t(nw,m,l+1) + c33 * workarrc_t(nw+1,m,l+1)
+               c_interp_1 = c31 * workarr_t(kpw-1,jp,ip)   + c32 * workarr_t(kpw,jp,ip)             &
+                          + c33 * workarr_t(kpw+1,jp,ip)
+               c_interp_2 = c31 * workarr_t(kpw-1,jp,ip+1) + c32 * workarr_t(kpw,jp,ip+1)           &
+                          + c33 * workarr_t(kpw+1,jp,ip+1)
 !
 !--            Use averages of the neighbouring matching grid-line values
-               DO  i = ifl(l), ifl(l+1)
-!                  f(k,jfl(m):jfu(m),i) = 0.5_wp * ( workarrc_t(nw,m,l)   &
-!                       + workarrc_t(nw,m,l+1) )
-                  f(k,jfl(m):jfu(m),i) = 0.5_wp * ( f_interp_1 + f_interp_2 )
+               DO  ic = ifl(ip), ifl(ip+1)
+                  child_array(kc,jfl(jp):jfu(jp),ic) = 0.5_wp * ( c_interp_1 + c_interp_2 )
                ENDDO
 !
 !--            Then set the values along the matching grid-lines  
-               IF  ( MOD( ifl(l), igsr ) == 0 )  THEN
-!
-!--            First interpolate to the flux point using the 3rd-order WS scheme
-                  f_interp_1 = c31 * workarrc_t(nw-1,m,l) + c32 * workarrc_t(nw,m,l) + c33 * workarrc_t(nw+1,m,l)                  
-!                  f(k,jfl(m):jfu(m),ifl(l)) = workarrc_t(nw,m,l)
-                  f(k,jfl(m):jfu(m),ifl(l)) = f_interp_1
+               IF ( MOD( ifl(ip), igsr ) == 0 )  THEN
+!
+!--               First interpolate to the flux point using the 3rd-order WS scheme
+                  c_interp_1 = c31 * workarr_t(kpw-1,jp,ip) + c32 * workarr_t(kpw,jp,ip)            &
+                             + c33 * workarr_t(kpw+1,jp,ip)                  
+                  child_array(kc,jfl(jp):jfu(jp),ifl(ip)) = c_interp_1
                ENDIF
 
@@ -4304,11 +4344,11 @@
 !
 !--      Finally, set the values along the last matching grid-line  
-         IF  ( MOD( ifl(icrw), igsr ) == 0 )  THEN
-            DO  m = jcsw, jcnw
+         IF  ( MOD( ifl(iprw), igsr ) == 0 )  THEN
+            DO  jp = jpsw, jpnw
 !
 !--            First interpolate to the flux point using the 3rd-order WS scheme
-               f_interp_1 = c31 * workarrc_t(nw-1,m,icrw) + c32 * workarrc_t(nw,m,icrw) + c33 * workarrc_t(nw+1,m,icrw)
-!               f(k,jfl(m):jfu(m),ifl(icrw)) = workarrc_t(nw,m,icrw)
-               f(k,jfl(m):jfu(m),ifl(icrw)) = f_interp_1
+               c_interp_1 = c31 * workarr_t(kpw-1,jp,iprw) + c32 * workarr_t(kpw,jp,iprw)           &
+                          + c33 * workarr_t(kpw+1,jp,iprw)
+               child_array(kc,jfl(jp):jfu(jp),ifl(iprw)) = c_interp_1
             ENDDO
          ENDIF
@@ -4318,8 +4358,8 @@
 !--      gap. Note however, this operation may produce some additional 
 !--      momentum conservation error.
-         IF  ( ifl(icrw) < nxr )  THEN
-            DO  m = jcsw, jcnw
-               DO  i = ifl(icrw)+1, nxr
-                  f(k,jfl(m):jfu(m),i) = f(k,jfl(m):jfu(m),ifl(icrw))
+         IF ( ifl(iprw) < nxr )  THEN
+            DO  jp = jpsw, jpnw
+               DO  ic = ifl(iprw) + 1, nxr
+                  child_array(kc,jfl(jp):jfu(jp),ic) = child_array(kc,jfl(jp):jfu(jp),ifl(iprw))
                ENDDO
             ENDDO
@@ -4328,23 +4368,23 @@
       ELSE IF  ( var == 'v' )  THEN
 
-         DO  l = iclw, icrw
-            DO  m = jcsw, jcnw-1
+         DO  ip = iplw, iprw
+            DO  jp = jpsw, jpnw-1
 !
 !--            First interpolate to the flux point using the 3rd-order WS scheme
-               f_interp_1 = c31 * workarrc_t(nw-1,m,l)   + c32 * workarrc_t(nw,m,l)   + c33 * workarrc_t(nw+1,m,l)
-               f_interp_2 = c31 * workarrc_t(nw-1,m+1,l) + c32 * workarrc_t(nw,m+1,l) + c33 * workarrc_t(nw+1,m+1,l)
+               c_interp_1 = c31 * workarr_t(kpw-1,jp,ip)   + c32 * workarr_t(kpw,jp,ip)             &
+                          + c33 * workarr_t(kpw+1,jp,ip)
+               c_interp_2 = c31 * workarr_t(kpw-1,jp+1,ip) + c32 * workarr_t(kpw,jp+1,ip)           &
+                          + c33 * workarr_t(kpw+1,jp+1,ip)
 !
 !--            Use averages of the neighbouring matching grid-line values
-               DO  j = jfl(m), jfl(m+1)          
-!                  f(k,j,ifl(l):ifu(l)) = 0.5_wp * ( workarrc_t(nw,m,l)   &
-!                       + workarrc_t(nw,m+1,l) )
-                  f(k,j,ifl(l):ifu(l)) = 0.5_wp * ( f_interp_1 + f_interp_2 )
+               DO  jc = jfl(jp), jfl(jp+1)          
+                  child_array(kc,jc,ifl(ip):ifu(ip)) = 0.5_wp * ( c_interp_1 + c_interp_2 )
                ENDDO
 !
 !--            Then set the values along the matching grid-lines  
-               IF  ( MOD( jfl(m), jgsr ) == 0 )  THEN
-                  f_interp_1 = c31 * workarrc_t(nw-1,m,l) + c32 * workarrc_t(nw,m,l) + c33 * workarrc_t(nw+1,m,l)
-!                  f(k,jfl(m),ifl(l):ifu(l)) = workarrc_t(nw,m,l)
-                  f(k,jfl(m),ifl(l):ifu(l)) = f_interp_1
+               IF ( MOD( jfl(jp), jgsr ) == 0 )  THEN
+                  c_interp_1 = c31 * workarr_t(kpw-1,jp,ip) + c32 * workarr_t(kpw,jp,ip)            &
+                             + c33 * workarr_t(kpw+1,jp,ip)
+                  child_array(kc,jfl(jp),ifl(ip):ifu(ip)) = c_interp_1
                ENDIF
                
@@ -4354,11 +4394,11 @@
 !
 !--      Finally, set the values along the last matching grid-line
-         IF  ( MOD( jfl(jcnw), jgsr ) == 0 )  THEN
-            DO  l = iclw, icrw
+         IF ( MOD( jfl(jpnw), jgsr ) == 0 )  THEN
+            DO  ip = iplw, iprw
 !
 !--            First interpolate to the flux point using the 3rd-order WS scheme
-               f_interp_1 = c31 * workarrc_t(nw-1,jcnw,l) + c32 * workarrc_t(nw,jcnw,l) + c33 * workarrc_t(nw+1,jcnw,l)
-!               f(k,jfl(jcnw),ifl(l):ifu(l)) = workarrc_t(nw,jcnw,l)
-               f(k,jfl(jcnw),ifl(l):ifu(l)) = f_interp_1
+               c_interp_1 = c31 * workarr_t(kpw-1,jpnw,ip) + c32 * workarr_t(kpw,jpnw,ip)           &
+                          + c33 * workarr_t(kpw+1,jpnw,ip)
+               child_array(kc,jfl(jpnw),ifl(ip):ifu(ip)) = c_interp_1
             ENDDO
          ENDIF
@@ -4368,8 +4408,8 @@
 !--      gap. Note however, this operation may produce some additional 
 !--      momentum conservation error.
-         IF  ( jfl(jcnw) < nyn )  THEN
-            DO  l = iclw, icrw
-               DO  j = jfl(jcnw)+1, nyn
-                  f(k,j,ifl(l):ifu(l)) = f(k,jfl(jcnw),ifl(l):ifu(l))
+         IF  ( jfl(jpnw) < nyn )  THEN
+            DO  ip = iplw, iprw
+               DO  jc = jfl(jpnw)+1, nyn
+                  child_array(kc,jc,ifl(ip):ifu(ip)) = child_array(kc,jfl(jpnw),ifl(ip):ifu(ip))
                ENDDO
             ENDDO
@@ -4378,13 +4418,13 @@
       ELSE  ! any scalar variable
 
-         DO  l = iclw, icrw
-            DO  m = jcsw, jcnw
+         DO  ip = iplw, iprw
+            DO  jp = jpsw, jpnw
 !
 !--            First interpolate to the flux point using the 3rd-order WS scheme
-               f_interp_1 = c31 * workarrc_t(nw-1,m,l) + c32 * workarrc_t(nw,m,l) + c33 * workarrc_t(nw+1,m,l)
-               DO  i = ifl(l), ifu(l)
-                  DO  j = jfl(m), jfu(m)
-!                     f(k,j,i) = workarrc_t(nw,m,l)
-                     f(k,j,i) = f_interp_1
+               c_interp_1 = c31 * workarr_t(kpw-1,jp,ip) + c32 * workarr_t(kpw,jp,ip)               &
+                          + c33 * workarr_t(kpw+1,jp,ip)
+               DO  ic = ifl(ip), ifu(ip)
+                  DO  jc = jfl(jp), jfu(jp)
+                     child_array(kc,jc,ic) = c_interp_1
                   ENDDO
                ENDDO
@@ -4397,5 +4437,5 @@
 !--   Just fill up the redundant second ghost-node layer in case of var == w.
       IF ( var == 'w' )  THEN
-         f(nzt+1,:,:) = f(nzt,:,:)
+         child_array(nzt+1,:,:) = child_array(nzt,:,:)
       ENDIF
 
@@ -4404,5 +4444,6 @@
 
 
-   SUBROUTINE pmci_anterp_tophat( f, fc, kct, ifl, ifu, jfl, jfu, kfl, kfu, ijkfc, var )
+   SUBROUTINE pmci_anterp_tophat( child_array, parent_array, kct, ifl, ifu, jfl, jfu, kfl, kfu,     &
+                                  ijkfc, var )
 !
 !--   Anterpolation of internal-node values to be used as the parent-domain
@@ -4413,55 +4454,67 @@
       IMPLICIT NONE
 
-      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(IN) ::  f         !< Child-grid array
-      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(INOUT)  ::  fc        !< Parent-grid array
-      INTEGER(iwp), DIMENSION(0:cg%nz+1,jcsa:jcna,icla:icra), INTENT(IN) :: ijkfc  !< number of child grid points contributing to a parent grid box
-      INTEGER(iwp), INTENT(IN) ::  kct                                             !< Top boundary index for anterpolation along z
-      INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
-      INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
-      INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
-      INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfu !< Indicates end index of child cells belonging to certain parent cell - y direction
-      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN) ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
-      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN) ::  kfu !< Indicates end index of child cells belonging to certain parent cell - z direction
+      INTEGER(iwp), INTENT(IN) ::  kct  !< Top boundary index for anterpolation along z
+      
+      INTEGER(iwp), DIMENSION(0:pg%nz+1,jpsa:jpna,ipla:ipra), INTENT(IN) ::  ijkfc  !< number of child grid points contributing
+                                                                                    !< to a parent grid box
+      INTEGER(iwp), DIMENSION(ipla:ipra), INTENT(IN) ::  ifl  !< Indicates start index of child cells belonging to certain
+                                                              !< parent cell - x direction
+      INTEGER(iwp), DIMENSION(ipla:ipra), INTENT(IN) ::  ifu  !< Indicates end index of child cells belonging to certain
+                                                              !< parent cell - x direction
+      INTEGER(iwp), DIMENSION(jpsa:jpna), INTENT(IN) ::  jfl  !< Indicates start index of child cells belonging to certain
+                                                              !< parent cell - y direction
+      INTEGER(iwp), DIMENSION(jpsa:jpna), INTENT(IN) ::  jfu  !< Indicates end index of child cells belonging to certain
+                                                              !< parent cell - y direction
+      INTEGER(iwp), DIMENSION(0:pg%nz+1), INTENT(IN) ::  kfl  !< Indicates start index of child cells belonging to certain
+                                                              !< parent cell - z direction
+      INTEGER(iwp), DIMENSION(0:pg%nz+1), INTENT(IN) ::  kfu  !< Indicates end index of child cells belonging to certain
+                                                              !< parent cell - z direction
+
+      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(IN) ::  child_array   !< Child-grid array
+      REAL(wp), DIMENSION(0:pg%nz+1,jps:jpn,ipl:ipr), INTENT(INOUT)  ::  parent_array  !< Parent-grid array
+
       CHARACTER(LEN=*), INTENT(IN) ::  var                   !< Variable symbol: 'u', 'v', 'w' or 's'
 !
 !--   Local variables:  
+      INTEGER(iwp) ::  ic              !< Running index x-direction - child grid
+      INTEGER(iwp) ::  ipl_anterp      !< Left boundary index for anterpolation along x
+      INTEGER(iwp) ::  ipr_anterp      !< Right boundary index for anterpolation along x
+      INTEGER(iwp) ::  jc              !< Running index y-direction - child grid
+      INTEGER(iwp) ::  jpn_anterp      !< North boundary index for anterpolation along y
+      INTEGER(iwp) ::  jps_anterp      !< South boundary index for anterpolation along y
+      INTEGER(iwp) ::  kc              !< Running index z-direction - child grid     
+      INTEGER(iwp) ::  kpb_anterp = 0  !< Bottom boundary index for anterpolation along z
+      INTEGER(iwp) ::  kpt_anterp      !< Top boundary index for anterpolation along z
+      INTEGER(iwp) ::  ip              !< Running index x-direction - parent grid
+      INTEGER(iwp) ::  jp              !< Running index y-direction - parent grid
+      INTEGER(iwp) ::  kp              !< Running index z-direction - parent grid
+      INTEGER(iwp) ::  var_flag        !< bit number used to flag topography on respective grid
+
       REAL(wp) ::  cellsum       !< sum of respective child cells belonging to parent cell 
-      INTEGER(iwp) ::  i         !< Running index x-direction - child grid
-      INTEGER(iwp) ::  iclant    !< Left boundary index for anterpolation along x
-      INTEGER(iwp) ::  icrant    !< Right boundary index for anterpolation along x
-      INTEGER(iwp) ::  j         !< Running index y-direction - child grid
-      INTEGER(iwp) ::  jcnant    !< North boundary index for anterpolation along y
-      INTEGER(iwp) ::  jcsant    !< South boundary index for anterpolation along y
-      INTEGER(iwp) ::  k         !< Running index z-direction - child grid     
-      INTEGER(iwp) ::  kcb = 0   !< Bottom boundary index for anterpolation along z
-      INTEGER(iwp) ::  kctant    !< Top boundary index for anterpolation along z
-      INTEGER(iwp) ::  l         !< Running index x-direction - parent grid
-      INTEGER(iwp) ::  m         !< Running index y-direction - parent grid
-      INTEGER(iwp) ::  n         !< Running index z-direction - parent grid
-      INTEGER(iwp) ::  var_flag  !< bit number used to flag topography on respective grid
-
-!
-!--   Define the index bounds iclant, icrant, jcsant and jcnant.
-!--   Note that kcb is simply zero and kct enters here as a parameter and it is
-!--   determined in pmci_define_index_mapping.
+
+!
+!--   Define the index bounds ipl_anterp, ipr_anterp, jps_anterp and jpn_anterp.
+!--   Note that kcb_anterp is simply zero and kct_anterp enters here as a
+!--   parameter and it is determined in pmci_define_index_mapping.
 !--   Note that the grid points used also for interpolation (from parent to
-!--   child) are excluded in anterpolation, e.g. anterpolation is only from 
-!--   nzb:kct-1, as kct is used for interpolation. An additional buffer is
+!--   child) are always excluded from anterpolation, e.g. anterpolation is maximally
+!--   only from nzb:kct-1, as kct is used for interpolation. Similar restriction is
+!--   applied to the lateral boundaries as well. An additional buffer is
 !--   also applied (default value for anterpolation_buffer_width = 2) in order
 !--   to avoid unphysical accumulation of kinetic energy.
-      iclant = icl
-      icrant = icr
-      jcsant = jcs
-      jcnant = jcn
-!      kctant = kct - 1
-      kctant = kct - 1 - anterpolation_buffer_width
-      kcb  = 0
+      ipl_anterp = ipl
+      ipr_anterp = ipr
+      jps_anterp = jps
+      jpn_anterp = jpn
+      kpb_anterp = 0
+      kpt_anterp = kct - 1 - anterpolation_buffer_width
+
       IF ( nesting_mode /= 'vertical' )  THEN
 !
 !--      Set the anterpolation buffers on the lateral boundaries
-         iclant = MAX( icl, iplg + 3 + anterpolation_buffer_width )
-         icrant = MIN( icr, iprg - 3 - anterpolation_buffer_width )
-         jcsant = MAX( jcs, jpsg + 3 + anterpolation_buffer_width )
-         jcnant = MIN( jcn, jpng - 3 - anterpolation_buffer_width )
+         ipl_anterp = MAX( ipl, iplg + 3 + anterpolation_buffer_width )
+         ipr_anterp = MIN( ipr, iprg - 3 - anterpolation_buffer_width )
+         jps_anterp = MAX( jps, jpsg + 3 + anterpolation_buffer_width )
+         jpn_anterp = MIN( jpn, jpng - 3 - anterpolation_buffer_width )
          
       ENDIF
@@ -4478,18 +4531,18 @@
       ENDIF
 !
-!--   Note that l, m, and n are parent-grid indices and i,j, and k 
+!--   Note that ip, jp, and kp are parent-grid indices and ic,jc, and kc 
 !--   are child-grid indices.
-      DO  l = iclant, icrant
-         DO  m = jcsant, jcnant
+      DO  ip = ipl_anterp, ipr_anterp
+         DO  jp = jps_anterp, jpn_anterp
 !
 !--         For simplicity anterpolate within buildings and under elevated
 !--         terrain too
-            DO  n = kcb, kctant
+            DO  kp = kpb_anterp, kpt_anterp
                cellsum = 0.0_wp
-               DO  i = ifl(l), ifu(l)
-                  DO  j = jfl(m), jfu(m)
-                     DO  k = kfl(n), kfu(n)
-                        cellsum = cellsum + MERGE( f(k,j,i), 0.0_wp,          &
-                             BTEST( wall_flags_0(k,j,i), var_flag ) )
+               DO  ic = ifl(ip), ifu(ip)
+                  DO  jc = jfl(jp), jfu(jp)
+                     DO  kc = kfl(kp), kfu(kp)
+                        cellsum = cellsum + MERGE( child_array(kc,jc,ic), 0.0_wp,                   &
+                             BTEST( wall_flags_0(kc,jc,ic), var_flag ) )
                      ENDDO
                   ENDDO
@@ -4501,7 +4554,6 @@
 !--            particular for the temperature. Therefore, in case cellsum is 
 !--            zero, keep the parent solution at this point. 
-
-               IF ( ijkfc(n,m,l) /= 0 )  THEN
-                  fc(n,m,l) = cellsum / REAL( ijkfc(n,m,l), KIND=wp )
+               IF ( ijkfc(kp,jp,ip) /= 0 )  THEN
+                  parent_array(kp,jp,ip) = cellsum / REAL( ijkfc(kp,jp,ip), KIND=wp )
                ENDIF
 
@@ -4539,13 +4591,13 @@
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i   !< Index along x-direction
-    INTEGER(iwp) ::  ib  !< running index for aerosol size bins
-    INTEGER(iwp) ::  ic  !< running index for aerosol mass bins
-    INTEGER(iwp) ::  ig  !< running index for salsa gases
-    INTEGER(iwp) ::  j   !< Index along y-direction
-    INTEGER(iwp) ::  k   !< Index along z-direction
+    INTEGER(iwp) ::  ic  !< Index along x-direction
+    INTEGER(iwp) ::  jc  !< Index along y-direction
+    INTEGER(iwp) ::  kc  !< Index along z-direction
+    INTEGER(iwp) ::  lb  !< Running index for aerosol size bins
+    INTEGER(iwp) ::  lc  !< Running index for aerosol mass bins
+    INTEGER(iwp) ::  lg  !< Running index for salsa gases
     INTEGER(iwp) ::  m   !< Running index for surface type
-    INTEGER(iwp) ::  n   !< running index for number of chemical species
-
+    INTEGER(iwp) ::  n   !< Running index for number of chemical species
+    
 !
 !-- Set Dirichlet boundary conditions for horizontal velocity components
